//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

sfr		ldata	=	0xB0;
sbit	rs		=	P3^2;
//sbit	rw		=	P3^3;
sbit	en		=	P3^3;

void msdelay(int a)
{				   
	int i,j;
	for(i=0;i<a;i++)
	{
		for(j=0;j<100;j++);
	}
}

void lcd_cmd(unsigned char lcmd)
{
	unsigned char temp;
	temp	=	lcmd;
	ldata	=	temp & 0xf0;
	rs		=	0;
	en		=	1;
	msdelay(1);
	en		=	0;

	temp	=	lcmd;	
	ldata	=	temp << 4;
	rs		=	0;
	en		=	1;
	msdelay(1);
	en		=	0;
	msdelay(5);
}

void lcd_data(unsigned char lcmd)
{
	unsigned char temp;
	temp	=	lcmd;
	ldata	=	temp & 0xf0;
	rs		=	1;
	en		=	1;
	msdelay(1);
	en		=	0;

	temp	=	lcmd;	
	ldata	=	temp << 4;
	rs		=	1;
	en		=	1;
	msdelay(1);
	en		=	0;
	msdelay(5);
}
void lcd_init(void)
{
//	rw		=	0;
	ldata	=	0x28;
	rs		=	0;
	en		=	1;
	msdelay(1);
	en		=	0;
	msdelay(5);
	
	lcd_cmd(0x28);//lcd as 4 bit mode
	lcd_cmd(0x0c);//display on cursor blinking 
	lcd_cmd(0x06);//increment
}
void lcd_line1(unsigned char *lcdstring)
{
	lcd_cmd(0x80);//first line
	while(*lcdstring)
	{
	lcd_data(*lcdstring++);
	}
}

void lcd_line2(unsigned char *lcdstring)
{
	lcd_cmd(0xC0);//second line
	while(*lcdstring)
	{
	lcd_data(*lcdstring++);
	}
}
void lcd_clear(void)
{	
	lcd_cmd(0x01);//clear
}

