#include <regx51.H>
//#include <serial_s.H>
#include<math.h>
#include<stdio.h>
#include<lcd.h>

#define adc_port1 P2              //ADC Port
#define adc_port2 P0
 
sbit rd1 =  P1^0;                //Read signal P1.0
sbit wr1 =  P1^1;               //Write signal P1.1
sbit cs1 =  P1^2;                //Chip Select P1.2
sbit intr1= P1^3;             //INTR signal P1.3

sbit rd2 =  P1^4;                //Read signal P1.0
sbit wr2 =  P1^5;               //Write signal P1.1
sbit cs2 =  P1^6;                //Chip Select P1.2
sbit intr2= P1^7;             //INTR signal P1.3

void conv(int);                     //Start of conversion function
void read(int);                     //Read ADC function
void msdelay(int);
void maths1();
void maths2();
unsigned char adc_val;
float val;
int temp ;
void main()
{
		//serial_init();
		lcd_init();
		lcd_clear();
        while(1)
		{                    
                conv(1);                  //Start conversion
                read(1);                  //Read ADC        
				maths1();
				msdelay(1000);

//                conv(2);                  //Start conversion
//                read(2);                  //Read ADC        
//				maths2();
//				msdelay(1000);


        }
}

void conv(int j)
{		
	if(j==1)
{
        cs1 = 0;                      //Make CS low
        wr1 = 0;                      //Make WR low
        wr1 = 1;                      //Make WR high
        cs1 = 1;                      //Make CS high
        while(intr1);                 //Wait for INTR to go low
}
else
{
		cs2 = 0;                      //Make CS low
        wr2 = 0;                      //Make WR low
        wr2 = 1;                      //Make WR high
        cs2 = 1;                      //Make CS high
        while(intr2);                 //Wait for INTR to go low
}

}

void read(int j)
{

		if(j==1)
	{
        cs1 = 0;                      //Make CS low
        rd1 = 0;                      //Make RD low
        adc_val = adc_port1;          //Read ADC port
        rd1 = 1;                      //Make RD high
        cs1 = 1;                      //Make CS high
	}

 	else
	
	{
	    cs2 = 0;                      //Make CS low
        rd2 = 0;                      //Make RD low
        adc_val = adc_port2;          //Read ADC port
        rd2 = 1;                      //Make RD high
        cs2 = 1;                      //Make CS high
	
	}

}



void maths1()
{
 				
				lcd_line1("voltage: ");
				val=(float)adc_val/51;
				temp =(int)val;
				lcd_data(temp+0x30);
				val=val-temp;
				lcd_data('.');
				val=val*10;
				temp=(int)val;
	            lcd_data(temp+0x30);
				val=val-temp;
				val=val*10;
				temp=(int)val;
				lcd_data(temp+0x30);

}


void maths2()
{
 				
				lcd_line2("current: ");
				val=(float)adc_val/51;
				temp =(int)val;
				lcd_data(temp+0x30);
				val=val-temp;
				lcd_data('.');
				val=val*10;
				temp=(int)val;
	            lcd_data(temp+0x30);
				val=val-temp;
				val=val*10;
				temp=(int)val;
				lcd_data(temp+0x30);

}